init python:
    config.keymap['button_ignore'].remove('mousedown_1')
    config.keymap['button_select'].remove('mouseup_1')
    config.keymap['button_select'].append('mousedown_1')

    config.keymap['button_alternate_ignore'].remove('mousedown_3')
    config.keymap['button_alternate'].remove('mouseup_3')
    config.keymap['button_alternate'].append('mousedown_3')

    import pygame

##ui elements not a part of the puzzle
screen puzzle_menu():
    default showdebug = False

    if solved:
        frame xpos 340 yalign .04 xpadding 40:
            label puzzle.name
        text _("touch to continue >") color "#985264" at tapcontinue
        dismiss action Jump("puzzle_result")

    else:
        timer 1.0 action SetVariable("puzzle_timer", puzzle_timer+1) repeat True modal True

        textbutton _("Save Progress") action ShowMenu("save") align (.5,.98) keysym "help"

        imagebutton auto "tutorial_%s":
            # align (1.0,.8) xoffset -32
            xalign .76
            yalign .02
            # action ToggleScreenVariable("showdebug")
            action ShowTransient("howtoplay")

        vbox:
            xalign 1.0
            xoffset -34
            ypos 100
            # align (.968,.04)
            label _("Select:") style "small_label"
            frame xsize 220:
                has vbox
                textbutton _("Paint") action SetVariable("paint", True) style "radio_button" activate_sound None
                # textbutton _("Check") action SetVariable("paint", True)
                textbutton _("Mark") action SetVariable("paint", False) style "radio_button" activate_sound None

        if showdebug:
            frame align (.96,.7):
                has vbox
                text "debug \o/"
                textbutton "solve" action Jump("solve_puzzle")
                textbutton "random puzzle" action Jump("random_puzzle")

        button align (.968,.96):
            xsize 220
            padding (20,24)
            background Frame("gui/frame2.png",20,20)
            hover_background Frame("gui/frame.png",20,20)
            text _("Start Over") xalign .5 style "choice_button_text"
            action Jump("start_puzzle")

        vbox:
            align (1.0,.02) xoffset -32
            style_prefix "side_menu"
            if gallery:
                textbutton _("Return to Gallery >") action Confirm(_("Give up and return to the Charm Gallery?"), Jump("puzzle_result"))
            else:
                if puzzle.id in persistent.finished_puzzles:
                    textbutton _("Skip Charm >") action Confirm(_("Skip this charm and return to the story?"), Jump("solve_puzzle"))

    vbox xsize 222:
        xpos 32
        ypos 100
        label _("Time:") style "small_label"
        hbox:
            frame xsize 160:
                if showtimer:
                    text "{}" .format(get_timer(puzzle_timer)) xpos 20
                else:
                    text _("=^.^=") xalign .5
            if not solved:
                imagebutton auto "showtime_%s" action ToggleVariable("showtimer") yalign .5

        null height 12

        frame xfill True:
            text _("Mistakes: [miss_counter]") size gui.interface_text_size

    if gallery:
        add "cassia_base_short" yalign 1.0
    else:
        add "cassia_base_longhair" yalign 1.0

    if reaction=="miss":
        add "cassia_face_waaa" yalign 1.0
    elif reaction=="touch":
        add "cassia_face_oops" yalign 1.0
        timer .8 action SetVariable("reaction", None)
    elif reaction=="hit":
        add "cassia_face_happy" yalign 1.0
    elif reaction=="thinking":
        add "cassia_face_oh" yalign 1.0
    else:
        add "cassia_face_smile" yalign 1.0

    if not solved:
        button xysize (120,120) align (0,1.0) offset (80,-80):
            action SetVariable("reaction", "touch")
            keyboard_focus False

screen reaction_timer():
    timer 1.5 action SetVariable("reaction", None)

#the actual puzzle
screen picross(puzzlesize):

    key "game_menu" action None
    key "rollback" action None
    key "toggle_skip" action None
    key "skip" action None

    if puzzlesize==5:
        default tilesize = 92
    elif puzzlesize==10:
        default tilesize = 44
    else:
        default tilesize = 28

    if not solved:
        add "gridguide"
    else:
        add "gridbase"

    ## puzzle grid ##

    frame xysize (484,484):
        background None# "#CA787A"
        padding (0,0)
        align (.5,.5) xoffset gui.puzzlexoffset

        grid puzzlesize puzzlesize:
            align (.5,.5)
            spacing 4
            for i in puzzle.rows:
                for x in i:
                    if x: ##hit
                        add Solid("#675145", xysize=(tilesize,tilesize))
                    else: ##miss
                        add Solid("#FFB6C8", xysize=(tilesize,tilesize))

        grid puzzlesize puzzlesize:
            align (.5,.5)
            offset (2,2)

            for c, i in enumerate(range(puzzlesize**2)):
                button xysize (tilesize+4,tilesize+4):
                    if c in coverset:
                        add "cover_tile"

                    background Solid("#fff", xysize=(tilesize,tilesize))
                    selected_background Solid("#FFE4C6", xysize=(tilesize,tilesize))
                    hover_foreground "hover_tile"

                    if c in autoset:
                        if c in missedset:
                            insensitive_background None
                        else:
                            insensitive_background Solid("#eee", xysize=(tilesize,tilesize))
                        if not solved:
                            add "auto_tile"
                    else:
                        insensitive_background None

                    sensitive c in buttonset

                    if c not in buttonset and c in missedset:
                        add "miss_tile"

                    if paint:
                        action [ SetVariable("tileno", c), Jump("uncover_tile")]
                    else:
                        action [ SetVariable("tileno", c), Jump("mark_tile")]

                    alternate [ SetVariable("tileno", c), Jump("cover_tile")]
                    # alternate_keysym "toggle_afm"
                    selected c in markedset

                    if pygame.mouse.get_pressed()[0]:
                        if paint:
                            hovered [ SetVariable("tileno", c), Jump("uncover_tile")]
                        else:
                            hovered [ SetVariable("tileno", c), Jump("mark_tile")]
                    elif pygame.mouse.get_pressed()[2]:
                        hovered [ SetVariable("tileno", c), Jump("cover_tile")]

    ## hints ##

    if not solved:
        ## column hints
        frame ysize 200 xoffset gui.puzzlexoffset:
            style_group "hint"
            xalign .5
            ypos 112
            yanchor 1.0
            has hbox
            yfill True
            xalign .5
            spacing 4

            for c, col in enumerate(col_hints):
                $ tilenos = col_list[c]
                vbox:
                    if gridsize!=15:
                        spacing -8
                    xsize tilesize
                    yalign 1.0
                    for count, y in enumerate(col):
                        textbutton "[y]":
                            padding (0,0)
                            xalign .5 keyboard_focus None
                            sensitive check_colhint_remaining(c, count, tilenos)
                            action NullAction()
                            if gridsize==15:
                                text_size 16
                            elif gridsize==5:
                                text_size 36
                            else:
                                text_size 24

        ## row hints
        frame xsize 180 xoffset gui.puzzlexoffset:
            style_group "hint"
            yalign .5
            xpos 208
            has vbox
            xanchor 1.0
            xalign 1.0
            if gridsize==15:
                spacing 1
            else:
                spacing 4

            for c, row in enumerate(row_hints):
                $ tilenos = row_list[c]
                hbox:
                    ysize tilesize
                    xalign 1.0
                    for count, x in enumerate(row):
                        textbutton "[x]":
                            keyboard_focus None yalign .5
                            sensitive check_rowhint_remaining(c, count, tilenos)
                            action NullAction()
                            if gridsize==15:
                                text_size 16
                            elif gridsize==5:
                                text_size 36
                            else:
                                text_size 24

style hint_frame:
    # background Frame("gui/small_frame.png",4,4)
    background None
    padding (0,0)
style hint_button_text:
    color gui.text_color
    insensitive_color gui.insensitive_color

transform lineappear:
    yzoom 0
    easein .25 yzoom 1.1
    easeout .15 yzoom 1.0
    pause 1.2
    easeout .3 yzoom 0

style small_label is gui_label
style small_label_text is gui_label_text

style small_label_text:
    color "#fff"
    size gui.quick_button_text_size
    outlines [(3,"#4E1E1B",0,0)]

screen winner():
    zorder 99
    modal True
    # on "show" action Play("sound", audio.)
    frame xsize 750:
        ysize 108
        xalign .5 yalign .48
        background Frame("gui/frame3.png",20,20)
        at lineappear
    hbox:
        align (.5,.48)
        add Text(_("You solved it!"), slow=True, slow_cps=30, size=50, color="#FFDEB8", outlines=[(6,"#fff",0,0),(3, "#4E1E1B",0,0)])

    timer 1.2 action Hide("winner", transition=Dissolve(.5))
    # textbutton _("OK!")

screen howtoplay():
    modal True
    add Solid("#ffaaaa80")
    style_group "tutorial"
    default dismissable = False
    timer .5 action SetScreenVariable("dismissable", True)
    if dismissable:
        dismiss action Return()

    frame xsize 640 align (.5,.5):
        xpadding 40
        has vbox
        spacing 4
        label _("~ Tutorial ~") xalign .5 text_size gui.label_text_size
        text _("Charms can be solved with the magic of logic!")
        text _("The numbers on the sides represent consecutive painted tiles found in each line.")
        add "tutorialpic1" xalign .5
        text _("When there are multiple numbers in a line, it means there must be at least one blank space between them, like so:")
        add "tutorialpic2" xalign .5
        text _("Determine which tiles must be painted until the final picture is revealed! (Mistakes won't affect the story. Just relax and have fun~)")
        null height 8

    #if not renpy.variant("touch"):
    frame xsize 240 align (.94,.66):
        xpadding 40
        has vbox
        xfill True
        label _("Controls") xalign .5 text_size gui.label_text_size
        null height 8
        label _("Left Click")
        text _("Paint/Mark") first_indent 0 xalign .5
        label _("Right Click")
        text _("Cross Out") first_indent 0 xalign .5
        null height 8

style tutorial_text:
    size gui.comment_text_size
    first_indent 20

style tutorial_label_text:
    size gui.comment_text_size

screen puzzle_gallery():
    $ tooltip = GetTooltip()

    if count_completed_puzzles()>=15:
        text _("all clear <3") color "#985264" xalign .7 yalign .986 at slowappear

    vbox:
        align (1.0,.02) xoffset -32
        style_prefix "side_menu"
        if gallery:
            textbutton _("Exit Gallery >") action Jump("ex_navi")

    frame padding (20,30) xsize 750:#220:
        background Frame("gui/frame3.png",20,20)
        align (.5,.125)
        # at showlesson
        style_prefix "side_menu"
        if tooltip:
            text "[tooltip]" xalign .5
        else:
            text _("Select a Charm~!") xalign .5

    grid 5 3:
        xsize 600 align (.5,.6)
        spacing 8
        $ mydelay = 0
        for i in all_puzzles:
            $ mydelay += .06
            button:
                activate_sound audio.start
                at choiceappear(mydelay)
                frame xysize (100,100):
                    hover_background Frame("gui/frame2.png",20,20)
                    if i.id in persistent.finished_puzzles:
                        tooltip i.name
                        if i.gridsize==5:
                            add i.image at zoomx(12.0) alpha .72 align (.5,.5)
                        elif i.gridsize==10:
                            add i.image at zoomx(6.0) alpha .72 align (.5,.5)
                        else:
                            add i.image at zoomx(4.0) alpha .72 align (.5,.5)
                    else:
                        tooltip _("???")
                        text "?" style "choice_button_text" align (.5,.5)
                action [SetVariable("puzzle", i), Jump("start_puzzle")]

init python:
    mr = MusicRoom()

    mr.add(audio.title, always_unlocked=True)
    mr.add(audio.puzzle1)
    mr.add(audio.puzzle2)
    mr.add(audio.puzzle3)
    mr.add(audio.puzzle4)
    mr.add(audio.puzzle5)
    mr.add(audio.gallery)

screen music_room():
    tag menu
    frame padding (20,24) xsize 265:
        background Frame("gui/frame3.png",20,20)
        align (.0,.02) xoffset 10 yoffset 1
        style_prefix "side_menu"
        text "[save_name!t]" xalign .5 alt ""

    frame padding (20,30) xsize 750:#220:
        background Frame("gui/frame3.png",20,20)
        align (.5,.125)
        style_prefix "side_menu"
        text _("~ Magical beats to study to ~") xalign .5

    hbox:
        xpos 300
        yalign .6

        frame:
            xsize 350
            xalign .5
            has vbox
            style_group "radio"
            xsize None
            # The buttons that play each track.
            textbutton _("Alluring Gallery") action mr.Play(audio.gallery) activate_sound None at choiceappear(0)#(.42)
            textbutton _("Charm Studies") action mr.Play(audio.title) activate_sound None at choiceappear(.06)
            textbutton _("Lucky Thimble") action mr.Play(audio.puzzle1) activate_sound None at choiceappear(.12)
            textbutton _("Steady Deduction") action mr.Play(audio.puzzle2) activate_sound None at choiceappear(.18)
            textbutton _("Immaculate Logic") action mr.Play(audio.puzzle3) activate_sound None at choiceappear(.24)
            textbutton _("Uncertainty Matrix") action mr.Play(audio.puzzle4) activate_sound None at choiceappear(.3)
            textbutton _("Discerning Witchcraft") action mr.Play(audio.puzzle5) activate_sound None at choiceappear(.36)

        null width 20

        frame:
            xsize 300
            style_group "comment"
            at slowappear#menuright
            # yfill True
            has vbox
            label _("Comment:")
            if renpy.music.get_playing(channel='music')==audio.gallery:
                text _("hey~ welcome to the music room! i wanted to include some commentary about the soundtrack this time, so i hope it will be interesting to read.")
            elif renpy.music.get_playing(channel='music')==audio.title:
                text _("i recently stumbled on a tutorial for making lo-fi songs, and it got me out of my music block! so, special thanks to Zectro on YouTube for inspiring this soundtrack.")
            elif renpy.music.get_playing(channel='music')==audio.puzzle1:
                text _("this was the first song i made, and it convinced me to go in this direction for the whole soundtrack.")
                text _("i think it suits Cassia really well, so now it's her theme song!")
            elif renpy.music.get_playing(channel='music')==audio.puzzle2:
                text _("for each song, i picked a random scale from the list in FL studio, and tried out some chords until it sounded nice.")
                text _("this one is my probably favorite :)")
            elif renpy.music.get_playing(channel='music')==audio.puzzle3:
                text _("the tracks came together very quickly... i'm really happy with all of them.")
                text _("this one is Senna's theme! ...but that was decided after the fact. i just used whatever suited the mood best.")
            elif renpy.music.get_playing(channel='music')==audio.puzzle4:
                text _("the story was only vaguely outlined when i made all the songs, so i went into these unsure if i would use every track...")
                text _("i don't listen to lo-fi casually, so i just made whatever i wanted.")
            elif renpy.music.get_playing(channel='music')==audio.puzzle5:
                text _("this was the last track to be completed! it's for the final boss (of puzzles).")
                text _("ahh, i want to make even more lo-fi songs now... i'm really glad i had an excuse to make this game real.")
                text _("thanks for reading!")

    text _("soundtrack + commentary by NomnomNami") color "#985264" xalign .55 yalign .986
    vbox:
        align (1.0,.02) xoffset -32
        style_prefix "side_menu"
        textbutton _("Exit Gallery >") action Jump("ex_navi")

style comment_frame:
    background None
    padding (0,10,0,0)

style comment_text:
    # color "#fff"
    size gui.comment_text_size

style comment_label_text is small_label_text
    # outlines [(3,"#4E1E1B",0,0)]

image credit game = Text(_("game by NomnomNami"), align=(.5,.24), text_align=.5, outlines=[(3,"#FFB6C8",0,0)])
image tlcredit = Text(_("translated by"), align=(.5,.5), text_align=.5, outlines=[(3,"#FFB6C8",0,0)])
image patroncredit = Text(_("supported by patrons"), align=(.5,.04), text_align=.5, outlines=[(3,"#FFB6C8",0,0)])
image credit thanks = Text(_("thanks for playing~!"), align=(.5,.24), text_align=.5, outlines=[(3,"#FFB6C8",0,0)])
image endtext = Text(_("THE END"), align=(.5,.24), text_align=.5, outlines=[(3,"#FFB6C8",0,0)])
