
default epilogue_intro = False

label ex_navi:
    if renpy.music.get_playing(channel='music')!=audio.title:
        play music title fadeout 1.0
    scene bg study
    $ _game_menu_screen = None
    $ gallery = True
    $ theend = False
    $ quick_menu = False
    $ solved = True
    $ showtimer = True
    $ paint = True
    $ puzzle = puzzle_easy_star
    $ save_name = _("Gallery")
    show screen chapter_name()

    menu (position="postgame"):
        "Epilogue":
            play sound button2
            jump epilogue_intro
        "Charm Gallery":
            play sound button2
            jump puzzle_navi
        "Music Room":
            play sound button2
            $ save_name = _("Music Room")
            if renpy.music.get_playing(channel='music')!=audio.gallery:
                play music gallery
            call screen music_room()
        "Return to Title":
            hide screen chapter_name
            pause .5
            scene bg pink with dissolve
            show titlelogo:
                align (.5,.25)
            with dissolve
            return

    jump ex_navi

label puzzle_navi:
    if renpy.music.get_playing(channel='music')!=audio.gallery:
        play music gallery fadeout 2.0
    call screen puzzle_gallery()
    jump puzzle_navi

label epilogue_intro:
    $ block()
    hide screen chapter_name
    $ _history_list = []
    pause .2
    scene bg study with fade
    $ _game_menu_screen = "save"
    $ quick_menu = True
    $ save_name = _("Epilogue")
    show screen chapter_name

    if not epilogue_intro:
        nvl clear
        "Classes were over for the third-year students, and Cassia was able to pass all of her finals..."
        "Only a few days remained before the graduation ceremony."
        nvl clear
        "This is the story of how Cassia spent her final days of high school..."
        nvl clear

        show cg school at cg
        show cassia short oh at appearleft
        c "Gosh... all the tests are over now, huh?"
        c smile "I don't have anything left to study... I'm really gonna graduate and leave this place behind!"
        c oops "I wonder if Senna would get mad at me for saying that...? Like, \"You should study the rest of your life, silly!\""
        c oh "...I don't know if she'd call me \"silly\" though. She'd probably have a smarter word for it..."
        c "...."
        $ epilogue_intro = True
    else:
        show cg school at cg

label epilogue_navi:
    show cassia short smile at left:
        alpha 1.0
    c smile "Huh? What was I doing?"
    menu:
        q "Decide what to do!"
        "Watch the clouds go by":
            play music puzzle1 fadeout 2.0
            pause .1
            jump epilogue1
        "(Complete 10 charms to unlock)" (unlock=False) if count_completed_puzzles()<10:
            jump epilogue_navi
        "Visit the school library" if count_completed_puzzles()>=10:
            play music puzzle2 fadeout 2.0
            pause .1
            jump epilogue2
        "(Complete 15 charms to unlock)" (unlock=False) if count_completed_puzzles()<15:
            jump epilogue_navi
        "Have lunch with Senna" if count_completed_puzzles()>=15:
            play music puzzle3 fadeout 2.0
            pause .1
            jump epilogue3

label epilogue1:
    $ save_name = _("Epilogue 1")
    c happy "I think for today, I'll just relax... after all those stressful tests, I think I earned some rest~!"
    hide cassia
    hide cg
    nvl clear
    "And so, Cassia laid down in the grass and looked up at the sky."
    nvl clear
    show cg clouds at cg
    "Soon, she would no longer be a student..."
    "What would her future hold from now on?"
    "School was the only thing she ever knew... what was it like out there, in the adult world?"
    nvl clear

    show cassia short oh at appearleft
    c oh "I'm gonna have to learn how to do taxes..."
    c whine "Wait... huh? Why didn't they teach something like that in school?"
    c worry "Momma says you get in big trouble if you mess those up... what if I mess up on mine?"
    c waaa "A-and adults gotta buy houses, too... how am I s'posed to buy a house? Aren't they expensive?!"
    c whine "I'm not ready to be an adult~~~! I wanna keep being a carefree student~~~~~!"

    show cassia waaa
    "Cassia began rolling around in the grass haphazardly..."
    "Just then, Senna happened to pass by."
    nvl clear

    show senna raised at appearright
    s raised "...Cassia? Ah, of course it's you. No one else would behave so childishly."
    c smile "Oh, Senna! I was just worrying about the future..."
    s hmm "Mm. I see you cut your hair after all."
    c happy "Hehe, I did! Do you like it~?"
    s sigh "I'm ambivalent."
    c "(I think that means she likes it~!)"
    s frown "What were those worries you mentioned? I have a spare moment, so feel free to confide in me if you'd like."
    c aww "Aww, Senna... that's so nice of you! <3"
    s bored "Yes, well... I'm making an effort to show interest in others' thoughts and feelings. (I'm also somewhat curious...)"
    c whine "Um, y'know how I was like, sooo worried about graduating?"
    c worry "Well, I didn't really start thinking about what comes after that until you asked me about it the other day!"
    c waaa "And I realized, I can't imagine myself doing all the stuff adults are s'posed to do! I don't think I'm ready...!"
    s raised "Hmm. What is it that you're imagining, exactly?"
    c whine "Like... I know I should try to get a job, but then I'm gonna have to like, pay taxes? And buy a house and stuff?"
    s grr "(In what world would this girl own property?)"
    c worry "What if I'm not smart enough to do all those kinds of things? I won't have you around to help tutor me...!"
    s sigh "I believe you're overestimating what will be asked of you upon graduation."
    c oh "I am...?"
    s hmm "Do you live with your parents?"
    c "Yeah..."
    s bored "And you're welcome there? They aren't going to ask you to move out as soon as you turn 18?"
    c oops "Actually, I think they'd worry a lot if I did!"
    s frown "Do you expect they'll ask you to pay some amount in rent if you continue living with them?"
    c oh "Huh...? Why would I need to pay to live in my own house?"
    s hmm "As expected, you are in the privileged position of not needing to seek employment immediately out of high school."
    s mad "Some witches MUST WORK to earn their place in this world. Consider yourself very, VERY lucky."
    c worry "Oh.... (Is Senna the kind who has to work...?)"
    s sigh "To put it simply, Cassia..."
    s frown "Your worries are completely superfluous. You won't be expected to file taxes, buy a house, or anything like that anytime soon."
    c happy "I won't...? Thank goodness~!"
    s bored "Yes. Now that your worries have been assuaged, I'll be on my way."
    c smile "Huh? O-okay! See ya later, Senna~!"
    hide senna

    c oh "...."
    c "(What's \"a-sway-j'd\"...?)"
    c worry "(More importantly... it sounds like Senna is the one who should be worried about what'll happen after she graduates!)"
    c waaa "(How can I help her...? School's gonna be over and I might never see her again!)"
    hide cassia

    "Cassia looked up at the clouds, searching for an answer."
    "Adult life was so far beyond her grasp, and yet... Senna seemed entirely too aware of what it would entail."
    nvl clear
    "It was Senna who helped her realize how immature she truly was."
    "Meanwhile, Cassia had the luxury of taking it slow... she understood that now."
    nvl clear
    hide cg
    "What could she do for her junior in the short time they had left...?"
    "Cassia thought long and hard about this... until she dozed off in the afternoon sun."
    nvl clear

    hide screen chapter_name
    play music title fadeout 2.0
    $ block()
    scene bg study with fade
    show cg school at cg
    $ save_name = _("Epilogue")
    show screen chapter_name()

    jump epilogue_navi

label epilogue2:
    $ save_name = _("Epilogue 2")
    c happy "I know! I'll go look for books in the library~!"

    hide cassia
    hide cg
    nvl clear
    "Cassia had thought and thought about what she could do to repay Senna for teaching her so much."
    "Surely she could find the answer in a book somewhere!"
    nvl clear
    show cg library at cg
    n2 "But the library contained an impossible amount of books..."
    n2 "How was she supposed to know which one might hold the answers she sought?"

    show cassia short oh at appearleft
    c "(Hmmmm~... I don't wanna pick out something with too many words...)"
    c happy "(How about a picture book~! Maybe a happy little story about friendship will tell me what to do...)"

    show cassia smile
    nvl clear
    n2 "Cassia wandered over to the children's section to look for a story that could help her."
    n2 "There was so much wisdom in storybooks, especially the ones for little kids, she thought. It was a great place to start."
    nvl clear

    c happy "(Picture books are so easy to understand... and you get pretty artwork to look at, too~!)"
    c smile "(Wow, this one looks cute... <3)"

    nvl clear
    n2 "Cassia quickly became immersed in her chosen storybook, forgetting her original goal."
    n2 "Meanwhile, Senna, who had been busy tutoring a second-year student at another table, took notice."
    nvl clear
    show senna bored at appearright
    s "(Is that the extent of her reading level...?)"
    s sigh "(Well, I can take a short break to greet her, at least... that would be the friendly thing to do.)"

    c happy "(Ehehe, this story is so nice... the characters are all so accepting of each other's problems~)"
    s frown "Cassia. I didn't expect to see you reading something of your own volition. (Even if it's a mere children's tale...)"
    c smile "Oh, hi, Senna! When did you get here?"
    s hmm "I DO still have other tutoring jobs... classes have only concluded for the third-years, not the rest of us."
    c oh "Oh...! Right, you're busy working...."
    s smile "I am, but I could use a brief rest. I thought I'd come over to say hello."
    c happy "Oh, you're on a break~! That's great... it'd be nice to get to talk to you a little more!"
    s oh "Would it? Why, did you have something you wanted to discuss?"
    c oh "Well..."
    c worry "(I need to let Senna know that I wanna support her in the future, after she graduates...)"
    c happy "(Maybe if I learn more about her, I can become more reliable as a friend~!)"
    s raised "...?"
    c smile "Say, can I ask you a bunch of questions? Is that okay~?"
    s hmm "Tentatively, yes. (What kind of questions...?)"
    c happy "What's your favorite color?"
    s frown "Gold."
    c smile "Do you like music?"
    s bored "Yes. (Who doesn't?)"
    c oh "Do you play any instruments?"
    s hmm "No."
    c happy "I know how to play piano! Want me to teach you?"
    s sigh "Not interested."
    c smile "What's your favorite class?"
    s frown "Arithmagic. (These questions are completely random...)"
    c oh "Oh, oh! What club are you in?! You never told me before!"
    s bored "Debate."
    c happy "Have you ever been in love~? <3"
    s grr "No comment."
    c smile "Do you have a familiar?"
    s hmm "No. (Does she...?)"
    c "If you could pick from all the different kinds of animal folk, which kind would you want as your familiar?"
    s sigh "I've always held respect for owls, as a people..."
    s hmm "But your question is flawed. The familiar chooses their master, not the other way around."
    c oh "Oh, you're right... Do you play any spo--"
    s frown "I'm going to stop you there. It seems you have an endless supply of these questions, and I do not have endless time."
    c happy "Ooh, is there a charm for that~? It'd be nice to spend forever getting to know each other!"
    s raised "Is that your goal...? Getting to know me?"
    c oh "Huh...? Yeah! I mean..."
    c worry "I want us to be friends for reals! But I'll be all graduated soon, so I gotta do it fast...!"
    s bored "Friendship isn't something that can be rushed... (Even I know that.)"
    c waaa "But how else can I repay you for all your help? W-we gotta stay in touch...!"
    s oh "Cassia..."
    s smile "You've already paid me. The material gain in itself is enough."
    c worry "But it doesn't FEEL like enough~! You're still working right now, even!"
    s frown "Tuition is expensive. I need to be prepared for college as well... there's always more money to be made."
    s sigh "But... my schedule happens to be clear tomorrow. Would you like to continue chatting then? (If it'd satisfy you...)"
    c happy "Oh...! Yeah~! That sounds great, Senna!"
    s smile "I'll meet you in the courtyard during lunch tomorrow, then. Goodbye for now."
    hide senna
    c smile "(Ehehe... tomorrow's my big chance to get closer to Senna~!)"
    hide cassia

    n2 "Pleased with her sudden leap in progress, Cassia happily returned to her picture book..."
    n2 "How will this story of friendship end? Will the two girls stay in touch, or drift apart...?"
    nvl clear
    hide cg
    "The answer is up to them..."
    nvl clear

    hide screen chapter_name
    play music title fadeout 2.0
    $ block()
    scene bg study with fade
    show cg school at cg
    $ save_name = _("Epilogue")
    show screen chapter_name()

    jump epilogue_navi

label epilogue3:
    $ save_name = _("Epilogue 3")
    c happy "Oh, yeah! I get to have lunch with Senna today~!"
    hide cassia
    nvl clear
    "Cassia hurried along to their meeting place in the courtyard."
    "She found Senna sitting beneath a large tree, holding a book in one hand and half a sandwich in the other."
    nvl clear

    show cassia short smile at appearleft
    show senna oh at appearright

    s "Ah, Cassia. My previous class let out a little early, so I went ahead and started eating..."
    c happy "Ehehe, do you always read while you eat?"
    s sigh "I often do, yes."
    c oh "You're not worried about getting crumbs stuck in the pages?"
    s hmm "I'm very careful."
    show cassia happy
    show senna frown

    "Cassia took a seat next to Senna and opened her lunchbox."
    "Apple slices, a small carton of milk, and..."
    nvl clear

    c smile "Oh! I got a sandwich today, too~!"
    s sigh "Do your parents prepare your lunches for you? (Must be nice...)"
    c happy "Ehehe, my Poppa makes 'em... Yaaay, it's peanut butter and banana! <3"
    s oh "Banana...?"
    s shock "Not peanut butter and jelly? Banana...?! What kind of food is this?!"
    c smile "You've never had one? They're my favorite!"
    s grr "No... I've never heard of this combination. (It sounds disgusting...)"
    c happy "It's yummy~! Here, try it!"
    s mad "Absolutely not. For one, it's unsanitary..."
    c oh "Huh...? Oh, it's okay, you can take a bite from the other side. I don't mind!"
    s sigh "I'm perfectly fine with my normal sandwich, thank you."
    c whine "Hey, mine's normal, too..."
    c smile "(Hehe, oh well.)"
    hide cassia
    hide senna

    "The girls sat in silence for a bit, with Cassia happily enjoying her sandwich while Senna continued to read."
    "Would this be the first and only time they ate together like this...?"
    nvl clear
    "The more Cassia thought about it, the more she wanted to hold on to this connection."
    "So she decided to start asking more questions."
    nvl clear
    show cassia short oh at appearleft
    show senna hmm at appearright

    c oh "Umm... Senna! I think you said, after you graduate and everything..."
    c oops "Well, I know there's still a long time before then! But you said you're gonna go to the top witch school..."
    c oh "So, like... where is that? Is it far away?"
    s frown "Figwood. Yes, it's quite far from here."
    c happy "Oh, the famous one! I've heard of that... I didn't know it was the top school~!"
    c oh "Wow, Figwood... that's like, across the whole country, right?"
    s smile "The InsteRail ticket is expensive, but it's at least a one-way trip. I'm looking forward to it, assuming they accept me."
    s hmm "(And assuming I'm able to get enough in scholarships... otherwise, my debt will be nightmarish....)"
    c smile "Going so far away, just for school... I've lived here in Krem my whole life, so I can't even imagine!"
    s frown "All in the name of getting the best education I can. It's the only way to pursue my dream."
    c happy "To be the best Logician ever~?"
    s smile "Yes, indeed."
    s sigh "...Macadamia wasn't my first choice for high school, you know."
    c oh "Really? You were gonna go somewhere else?"
    s frown "Yes, Plumbridge. It's an all-girls boarding school... some of the most brilliant witches in the world were taught there."
    c oops "Ohh, I've heard of that one, too... (For different reasons...)"
    s sigh "Unfortunately, my transfer request was denied. It seems that school is quite exclusive..."
    s hmm "Plumbridge would've looked much more attractive on my college application. It's a shame I couldn't transfer."
    c smile "Here is better anyway~!"
    c oops "I mean, they never woulda let ME into a school like that..."
    s bored "Yes, you'd need to learn to pay attention in class first."
    c oh "Oh, no, I mean... They're SUUUPER traditional, right?"
    c smile "That's the kind of school where they wouldn't even recognize me as a girl."
    s oh "Hm...? Why wouldn't they? You clearly are."
    c happy "Ehehe~ Thanks, Senna~"
    s raised "????"

    hide cassia
    hide senna
    nvl clear
    "The lunch hour would be over soon..."
    "Maybe their paths in life were always meant to diverge here."
    "But Cassia just couldn't help reaching out..."
    nvl clear
    show cassia short worry at appearleft
    show senna frown at appearright

    c worry "You wanna know something? I'm, um... I'm still worried about what comes after graduation."
    s bored "About your responsibilities as an adult? As I said before, those things are still very far off for you..."
    c whine "No, no! I know I'll be okay... but what about you?"
    s oh "Me...?"
    c oops "Remember when you said... well, maybe you didn't say it exactly..."
    c worry "It sounded like you're gonna have a lot of responsibilities after you graduate..."
    c waaa "A-and even right now, you're working lots of jobs! That sounds so hard~!"
    s frown "Such is life. I'm working hard in pursuit of my goals, as anyone should."
    c worry "I just thought... is Senna gonna be okay after I'm gone? What can I do to help?"
    c whine "I really wanted to do something for you, or... or at least make sure you knew you could count on me, as a friend...!"
    s oh "...."
    s hmm "Cassia, I would never willingly choose to rely on you for anything."
    c waaa "Noooo...! S-say it isn't so~!"
    s bored "It may sound harsh, but it's the truth. We've barely interacted until now."
    c worry "W-well, yeah, but..."
    s frown "I can handle myself. I've already gotten this far on my own..."
    s smile "So there's no need for you to worry about me. I do appreciate the sentiment, though."
    c whine "You'll really be okay...?"
    s sigh "Yes. I promise."
    c "We'll keep in touch after graduation?"
    s raised "We have nothing in common... why are you so insistent about this?"
    c waaa "We do too have stuff in common! W-we both went to the same school!"
    s hmm "Yes, and the list ends there."
    c "You don't wanna stay friends just cuz you think my Poppa's sandwiches are weird?!"
    s shock "I didn't say that...!"
    c worry "You helped me a lot, so I... I don't want this to be the last time I ever see you!"
    s sigh "Cassia..."
    s frown "Our paths in life are going to look very different. It's likely that this WILL be the last time we meet."
    s smile "But... some encounters are fleeting. It's part of what makes them memorable."
    c oh "...."
    c happy "Then, you'll remember me...? That's so nice~!"
    s aww "Yes, of course I will. You're hard to forget."
    c smile "I won't forget you, either! You taught me so much...!"
    s smile "I hope you'll keep studying from now on. Regardless of your future career."
    c happy "Yeah~! Drawing charms turned out to be pretty fun!"
    s aww "As your tutor, I'm delighted to hear it."

    hide senna
    hide cassia

    "And with that, their lunch together was over."
    "The two girls said their goodbyes, and parted ways..."
    nvl clear
    hide cg
    "Whether or not their paths would somehow cross again in the future... only time would tell."
    "For now, Cassia felt at ease knowing that Senna would remember their time together."
    nvl clear
    "She would always be cheering her on... to become the best Logician in the world."
    nvl clear

    hide screen chapter_name
    $ quick_menu = False
    $ _game_menu_screen = None
    # stop music fadeout 2.0
    $ block()
    play music title fadeout 2.0
    scene bg pink with Dissolve(1.5)

    show endtext
    show cg book
    with Dissolve(1)

    pause

    hide cg
    hide endtext
    with Dissolve(1)
    pause 1

    jump to_title

label leave_epilogue:
    scene bg study with fade
    jump ex_navi
