﻿# The script of the game goes in this file.

# Declare characters used by this game. The color argument colorizes the
# name of the character.

define c = Character(_("Cassia"), image='cassia', color="#FFB6C8")
define s = Character(_("Senna"), image='senna', color="#FFDEB8")
define q = Character(None, what_prefix="{cps=0}", window_background="gui/textbox2.png", screen="think")
define narrator = Character(None, kind=nvl)
define n2 = Character(None, kind=nvl, what_outlines=[(3,"#EFC9BE",0,0)])

image side cassia = "side_cassia"
image side senna = "side_senna"

layeredimage cassia:
    group base auto:
        attribute longhair default

    group face auto:
        attribute smile default

layeredimage senna:
    always "senna_base"

    group face auto:
        attribute frown default

image bg pink = Solid("#DC7891")

image mm_star:
    "images/titlestar.png"
    alpha .5
    subpixel True
    rotate 0
    linear 5 rotate -360
    repeat

image mm_square:
    "images/titlesquare.png"
    zoom .75
    alpha .5
    subpixel True
    rotate 0
    linear 5 rotate 360
    repeat

image mmblossom1 = SnowBlossom("mm_star", count=20, xspeed=(0,1), start=3)
image mmblossom2 = SnowBlossom("mm_square", count=20, xspeed=(0,1), start=3)
image mmblossoms:
    contains:
        "mmblossom1"
    contains:
        "mmblossom2"

transform appearleft:
    xalign 0
    yalign 1.0
    alpha 0 xoffset -30
    easein .5 alpha 1.0 xoffset 0
    on hide:
        alpha 1.0 xoffset 0
        easein .5 alpha 0 xoffset -30
transform appearright:
    xalign 1.0
    yalign 1.0
    alpha 0 xoffset 30
    easein .5 alpha 1.0 xoffset 0
    on hide:
        alpha 1.0 xoffset 0
        easein .5 alpha 0 xoffset 30

transform tapcontinue:
    xalign .7 yalign .986
    alpha 0 xoffset -30
    pause 1.5
    easein .5 alpha 1.0 xoffset 0

transform cg:
    xalign .5 ypos 80
    yanchor .5 yoffset 177
    yzoom 0 alpha 0
    easein .18 yzoom 1.0 alpha 1.0
    on hide:
        easein .18 yzoom 0 alpha 0

init python:

    def block():
        config.skipping = None
        renpy.checkpoint()
        renpy.block_rollback()
        renpy.retain_after_load()
        renpy.save_persistent()

default persistent.finished_puzzles = [] #tracks completed puzzles

label splashscreen:
    scene black
    # if not persistent.setlanguage:
    #     call screen langset
    #     $ persistent.setlanguage=True
    show splash with dissolve
    pause 2
    hide splash with fade
    scene bg pink with dissolve
    show titlelogo:
        align (.5,.25)
    with dissolve
    return

label start:
    scene bg pink
    # play music title
    $ quick_menu = False
    $ showtimer = True #show/hide puzzle timer in ui
    $ solved = True #hides history
    $ paint = True #fill tiles vs just marking them
    $ gallery = False #determines if we're in postgame
    $ extracredit = False #bonus charm on day 1
    $ theend = False
    $ puzzle = puzzle_easy_star
    $ save_name = _("After School")

    pause .1
    scene bg study
    with dissolve
    $ quick_menu = True
    $ block()

label opening:
    "Many years ago, a little witch named Cassia was in serious academic trouble..."
    nvl clear

    show screen chapter_name()
    show cg school at cg
    show cassia waaa at appearleft
    c waaa "Waaah! I'm late, I'm late...!"
    c worry "My tutor's gonna be so mad... Ohhh, I hope she isn't mad...!"
    hide cassia

    "If Cassia didn't do something about her grades, she was going to fail Charms class."
    "And if she failed now... she was in danger of flunking out!"
    nvl clear

    show cassia waaa at appearleft
    c waaa "I don't wanna repeat a year... I wanna graduate with all my friends!"
    c oh "Gotta hurry up and get to the library... Umm, which way was that again...?"
    hide cassia
    hide cg
    "She wasn't very good at studying, but..."
    "As long as someone was there to explain things to her slowly, she could understand anything!"
    "...Eventually."
    nvl clear
    show cg library at cg

    show cassia happy at appearleft
    c "I made it~! Thank goodness..."
    show senna hmm at appearright
    s hmm "You're 20 minutes late."
    c waaa "Wahh! (She's mad after all...)"
    hide screen chapter_name
    $ save_name = _("Lesson 1")
    show screen chapter_name()
    s sigh "Sit here. We'll begin with this charm..."
    c oh "Huh...? We're starting already?"
    s bored "I thought we should make the most of our time together. Since you were late."
    c smile "Oh, yeah...! Let's make the most of it, Senna~!"
    c oops "For the sake of my grades... ehehe..."
    hide cg
    hide senna
    hide cassia
    pause .2
    show cg puzzle at cg
    n2 "Cassia took her seat and stared blankly at the grid in front of her."
    n2 "Normally, she loved to draw in class... but charms were different."
    nvl clear

    show senna at appearright
    show cassia oh at appearleft

    s sigh "...Please draw the charm according to the instructions."
    c oops "Okay~! Ummm...."
    s raised "...You DO know how to complete something this simple, right?"

    menu:
        q "Do you know how to do this type of puzzle?"
        "Yes! (confident)":
            pause .1
            c happy "Yeah, I can do it~! I've done lots before..."
        "Yes! (lie)":
            pause .1
            c smile "Easy peasy~! I'll solve it in no time."
        "No...":
            pause .1
            c worry "I forget... can you teach me~?"
            s sigh "I've included a tutorial sheet, so please refer to that. I trust you can figure it out on your own."
            c whine "But, but... I'm not good with puzzles! What if I mess it up?"
            s frown "Mistakes won't be penalized. I'm not grading you... it's only practice."
            c happy "Whew... okay, that makes me feel better! Thank you, Senna."
    s hmm "...Great. Go ahead, then."
    hide senna
    hide cassia
    hide cg
    "In all honesty, Cassia could never remember how to read the instructions to draw charms correctly..."
    "But she was going to do her best!"
    nvl clear
    show cassia at appearleft
    c "(I can do this! I don't want Senna to think I'm a dummy...!)"

label skipto_puzzle:
    ##omg why is there no easier way to do this hjdskhgj
    if puzzle.id=="star":
        $ save_name = _("Lesson 1")
    elif puzzle.id=="time":
        $ save_name = _("Lesson 2")
    elif puzzle.id=="space":
        $ save_name = _("Lesson 3")
    elif puzzle.id=="candy": ##bonus charm
        $ save_name = _("Extra Credit!")
    elif puzzle.id=="connection":
        $ save_name = _("Lesson 4")
    elif puzzle.id=="illusion":
        $ save_name = _("Lesson 5")
    elif puzzle.id=="growth":
        $ save_name = _("Lesson 6")
    elif puzzle.id=="cat":
        $ save_name = _("Extra Credit!")
    elif puzzle.id=="book":
        $ save_name = _("Lesson 7")
    elif puzzle.id=="circle":
        $ save_name = _("Final Lesson")

    if not theend:
        show screen chapter_name()

label start_puzzle:
    if theend:
        jump ending
    pause .02
    scene bg study
    # show screen begin_puzzle()
    play music puzzle.song fadeout 2.0

    python:
        quick_menu = False
        # buildin the puzzle
        gridsize = puzzle.gridsize #5x5, 10x10, or 15x15
        buttonset = set(range(gridsize**2)) #tiles to click on
        tileno = 0 #for checking what tile we clicked on
        reaction = None #for cassia faces

        # pre-defined stuff we only calculate once
        miss_set = puzzle.misses()
        hit_set = puzzle.hits()
        puzzle_columns = puzzle.columns()

        row_list = get_tilenumbers()[0]
        col_list = get_tilenumbers()[1]
        row_key = get_row_key()
        column_key = get_col_key()

        row_hints = get_all_hints(puzzle.rows)
        col_hints = get_all_hints(puzzle_columns)

        # initialize player progress
        puzzle_timer = 0
        solved = False
        miss_counter = 0
        markedset = set() #tiles player has marked (highlighted)
        coverset = set() #tiles player has covered (light x)
        missedset = set() #tiles player has gotten wrong (red x)
        autoset = set() #tiles that have autofilled (gray x)

        #fill 0s at start
        for row in row_list:
            tileno = row[0]
            coords = get_tile_coords(tileno)
            remaining_tiles = check_cleared_line(tileno)

            if not remaining_tiles[0]:
                autocomplete_row()

        for col in col_list:
            tileno = col[0]
            coords = get_tile_coords(tileno)
            remaining_tiles = check_cleared_line(tileno)

            if not remaining_tiles[1]:
                autocomplete_col()

    show screen puzzle_menu()
    show screen picross(puzzlesize=gridsize)

label study:
    call screen reaction_timer()
    $ block()
    pause

label mark_tile:
    $ reaction = "thinking"
    if pygame.mouse.get_pressed()[0]:
        if tileno in markedset:
            $ markedset.discard(tileno)
        else:
            $ coverset.discard(tileno)
            $ markedset.add(tileno)
    jump study

label cover_tile:
    if pygame.mouse.get_pressed()[2]:
        $ reaction = "thinking"
        if tileno in coverset:
            $ coverset.discard(tileno)
        else:
            $ markedset.discard(tileno)
            $ coverset.add(tileno)
    jump study

label uncover_tile:
    if pygame.mouse.get_pressed()[0]:
        $ coverset.discard(tileno)
        $ buttonset.discard(tileno)
        $ coords = get_tile_coords(tileno)
        $ remaining_tiles = check_cleared_line(tileno) #2 sets

        if tileno in miss_set:
            $ reaction = "miss"
            $ miss_counter += 1
            $ missedset.add(tileno)
        else:
            if not remaining_tiles[0]:
                $ autocomplete_row()
                $ reaction = "hit"
            if not remaining_tiles[1]:
                $ autocomplete_col()
                $ reaction = "hit"

            if check_solved(puzzle):
                jump finish
    jump study

label solve_puzzle:
    $ buttonset = miss_set #only miss tiles are active
    jump finish

label random_puzzle:
    $ puzzle = renpy.random.choice(all_puzzles)
    jump start_puzzle

label finish:
    $ solved = True
    $ markedset = set()
    $ coverset = set()
    $ persistent.finished_puzzles.append(puzzle.id)
    play sound solve
    $ block()
    show screen winner()
    jump study

label puzzle_result:
    hide screen puzzle_menu
    hide screen picross
    hide screen reaction_timer
    $ block()

    if gallery:
        jump puzzle_navi
    else:
        $ quick_menu = True
        $ _history_list = []
        call next_scene from _call_next_scene

    jump start_puzzle

label next_scene:

    if puzzle.id=="star":
        $ puzzle = puzzle_easy_time
        jump lesson1
    elif puzzle.id=="time":
        $ puzzle = puzzle_easy_space
        jump lesson2
    elif puzzle.id=="space":
        $ puzzle = puzzle_mid_connection
        jump lesson3
    elif puzzle.id=="candy":
        $ puzzle = puzzle_mid_connection
        jump part2
    elif puzzle.id=="connection":
        $ puzzle = puzzle_mid_illusion
        jump lesson4
    elif puzzle.id=="illusion":
        $ puzzle = puzzle_mid_growth
        jump lesson5
    elif puzzle.id=="growth":
        $ puzzle = puzzle_mid_book
        jump lesson6
    elif puzzle.id=="cat": ##bonus charm
        $ puzzle = puzzle_mid_book
        jump part3
    elif puzzle.id=="book":
        $ puzzle = puzzle_hard_circle
        jump lesson7
    elif puzzle.id=="circle":
        jump lesson8
    else:
        #cant return from here or it redoes the puzzle
        jump ending

label lesson1:
    show cg library at cg
    show cassia happy at left
    show senna at appearright

    c "Yay~ I finished it!"

    if miss_counter:
        s hmm "...If you made a mistake on a charm as simple as this, we have a lot of work to do."
        c oops "Ehehe... sorry...."
    else:
        s bored "Good. So you know how to follow instructions after all."
        c smile "I did my best!"

    s frown "I'll be honest... you're always sleeping in class. So I didn't expect anything from you."
    c whine "Aww, but it's right after lunchtime! And my desk is by the window..."
    c happy "I just get so full, and warm, and cozy... that I end up falling asleep~ I can't help it~!"
    s hmm "That's why you're on the verge of failing."
    c oops "Ehehe~ yeah, that's true..."

    hide screen chapter_name
    $ save_name = _("Pop Quiz!")
    show screen chapter_name()
    s sigh "If you don't mind, I'm going to quiz you between charms to ensure you understand the material correctly."
    c happy "Oh! Quizzes are exciting!"
    s oh "Really? I assumed you'd dread them."
    c oh "Have you ever taken those, umm... from magazines and stuff..."
    c smile "Oh, personality quizzes! I really love those~"
    s hmm "...No. Let's stay on track."
    s frown "Can you identify the charm you just drew?"

    menu:
        q "What charm did you draw?"
        "Astral Magic":
            pause .1
            c oh "Umm, it was the charm for Astral Magic, right?"
            s sigh "Yes, it is."
            s frown "Astral charms bring good luck. They're exceedingly common; perfect for beginners."
        "Diamond Charm!":
            pause .1
            c happy "Oh, I know! It was diamond-shaped!"
            s grr "Wrong. It's the charm for Astral Magic."
            s hmm "Astral charms bring good luck. And it's meant to be a star, not a diamond."
        "A good luck charm~":
            pause .1
            c happy "It's the charm for good luck! I have a necklace with one drawn on it~!"
            s hmm "That's... half correct."
            s sigh "It's the charm for Astral Magic. And yes, it brings luck."

    c aww "Aww, I think stars are just so cute... I like when they're all rounded at the ends. Ehehe~"
    s frown "Okay. Next question..."
    s oh "Considering we're starting with the fundamentals, what are the next two charms I'm going to have you draw?"
    show cassia smile

    menu:
        q "Which charms will come next?"
        "Time and Space?":
            pause .1
            c oh "Umm... that'd be time and space, right?"
            s sigh "Correct. They're the other two main pillars of the magic circle."
            c whine "Aww, but isn't it cheating if you tell me beforehand...?"
            s raised "Cheating?"
            c "I'll know how to draw it without reading the instructions! That's not fair..."
            s sigh "Then please read the instructions anyway, just to be sure."
        "Bad luck and neutral luck!":
            pause .1
            c oh "Since we did good luck, the next ones have gotta be neutral and bad luck!"
            s hmm "...Wrong. I was talking about the other main pillars of magic: Time and Space."
            c aww "Oh, good... I didn't wanna draw a bad luck charm."
            c worry "What if I drew it and slept in on the day of the final...?! Then I'd fail for sure!"
            s sigh "You certainly would."
        "I dunno~":
            pause .1
            c aww "I can't see the future, Senna... Why don't you just show me~?"
            s sigh "...Alright. Fair enough, I suppose."

    hide screen chapter_name
    $ save_name = _("Lesson 2")
    show screen chapter_name()
    s frown "Here's the next puzzle. Try to finish it quickly so we can move on."
    c happy "Okay~!"
    hide senna
    hide cg
    return

label lesson2:
    show cg library at cg
    show cassia happy at left
    show senna at appearright

    c "I did it, Senna~! It's the hourglass one!"
    s hmm "Temporal Magic, yes."
    c oh "Um... what does this one do again?"
    s bored "You tell me. I'm sure you know it."

    menu:
        q "What does the temporal charm do?"
        "Does it tell time?":
            pause .1
            c smile "This one's on clocks and stuff, right? So it keeps the time!"
            s sigh "...Yes. It ensures that time will flow steadily."
            c happy "Yay~ I got it right!"
        "Makes you go fast!!!":
            pause .1
            c happy "Ohh, this must be the one that makes you go like, WHOOSH~!"
            s raised "\"Whoosh\"?"
            c smile "Like, you draw it on things you want to go fast! Whoooosh~"
            s hmm "...No. This charm ensures that time will flow steadily."
        "Slows things down...?":
            pause .1
            c oops "Is it like... \"take your time\"? So it means slow down?"
            s hmm "...No. This charm ensures that time will flow steadily."

    s frown "To affect time in different ways, you would need to draw a combination of more complex charms."
    c whine "Why can't I just cast a spell~? It's so much easier than writing these out..."
    s grr "(Do I really have to explain this...?)"
    s mad "Charms are essential for magical tools. Objects can hold magic much longer when charms are drawn into them."
    c oh "Ohh, right... that sounds pretty useful. Especially for people who like, can't use magic and stuff..."
    s sigh "How old are you, Cassia?"

    menu:
        q "How old are you?"
        "17!":
            pause .1
            c smile "I just turned 17! Do you wanna know when my birthday is~?"
            s grr "No. You're getting distracted."
        "You first!":
            pause .1
            c smile "You go first, Senna! How old are you, and when is your birthday?"
            s hmm "15, and why do you care?"
            c happy "Ohh, that's right, you're still a first-year~! Hehe, I'm older than you~!"
            s mad "You're being childish. Stop getting distracted."
            c oops "Hehehe... sorry <3"
        "Umm, I forget.":
            pause .1
            c smile "16... no, 17!"
            s raised "You can't even remember your own age...?"
            c oops "Ehe, sorry, I forgot my birthday was just last week~"
            c worry "I guess I've been really stressed out about my grades, so I'm all jumbled up..."

    s raised "My point is... you should know these things by now. Aren't you embarrassed, as a witch?"
    c oh "Huh...? What is there to be embarrassed about?"
    c oops "Everybody calls me an airhead, so, um... maybe it's like..."
    c worry "What's it called...? When someone like, thinks something, but then it totally happens?"
    s bored "A self-fulfilling prophecy?"
    c happy "Yeah~! One of those thingies!"
    s hmm "...You DO want to learn, right? Or are we both wasting our time here today?"
    c whine "I wanna pass Charms class so I can graduate with everybody! You said you'd help me, Senna..."
    s sigh "Yes, I did..."
    hide screen chapter_name
    $ save_name = _("Lesson 3")
    show screen chapter_name()
    s frown "Here. Draw this last charm. I have club activities after this, so..."
    c smile "Oh, what club are you in?"
    s hmm "The charm, Cassia."
    c oh "Oh, right! Focus...!"
    hide senna
    hide cg

    return

label lesson3:
    show cg library at cg
    show cassia worry at appearleft
    show senna at appearright

    c worry "These are getting kinda tricky... how does anybody fill them out without guessing?"
    s "It's by process of elimination. You're testing out the possibilities by marking them, right?"
    c oh "Marking...? Oh, yeah!"
    c happy "If I mark them first, I can see if all the numbers will match up! That's so smart~!"
    s hmm "Did you sleep through the whole semester...? These are the absolute basics."
    c worry "That's why I need your help, Senna...!"
    c oops "I like all my classes when they first start, but like... if I fall behind even a little bit, I get totally lost..."
    c happy "But I feel like I'm catching up now~! You've helped so much already!"
    s sigh "Glad to hear it... (Does she just not even try, normally?)"
    hide screen chapter_name
    $ save_name = _("Review")
    show screen chapter_name()
    s frown "I'll give you one last quiz to review what we went over today. Are you ready?"

    menu:
        q "Ready for the quiz?"
        "Yeah~!":
            pause .1
            c smile "I'm ready~! Quiz me, quiz me!"
        "Not really...":
            pause .1
            c oops "Ehehe, I hope I can get the answers right..."
        "I'm hungry~":
            pause .1
            c smile "Ohh, I wanna recharge first... Do you have any snacks~?"
            s hmm "No. Food and drinks aren't allowed in the library."
            c whine "Awww... not even a piece of candy~?"
            s grr "(How childish can you be...?!)"

    s sigh "Question 1: What was the last charm I had you draw?"

    menu:
        q "What was the last charm?"
        "Spatial Magic!":
            pause .1
            c happy "The space one! Spatial magic."
            s frown "Good job. You identified it correctly."
        "Bubble charm~!":
            pause .1
            c happy "Oh, I know! The bubbly one!"
            s raised "\"Bubbly\"...?"
            c smile "See, it's a big circle with a bunch of little bubbles inside!"
            c happy "So cute~! I love this charm!"
            s mad "They aren't bubbles. And it isn't cute. (Take this seriously!)"
        "...I forgot.":
            pause .1
            c oh "Oh... what was it again...?"
            s mad "You need to pay attention to the patterns you're drawing. Do you want to pass, or not?"
            c worry "Sorry... I was so focused on making the numbers match up, I forgot to look at the picture!"

    s sigh "The Spatial charm's function is stabilization. It's commonly engraved into the exteriors of large buildings."
    c smile "Oooh... like on the walls of our city~?"
    s frown "Yes, like on the outer walls. These sorts of measures are necessary in places with a high concentration of magic."
    c oh "Necessary...? Why?"
    s hmm "The city might collapse in on itself otherwise. This charm prevents that."
    c whine "Collapse...! That sounds really bad!"
    c happy "Thank goodness the charms on the wall will protect us~! Ehehe..."

    s frown "Question 2: For tomorrow's session, what size will the charm grids be?"

    menu:
        q "How big will the grids be next time?"
        "5 x 5!":
            pause .1
            c aww "I wanna do more 5 x 5 ones! They're so fun~!"
            s bored "Too bad. You won't know enough for the final if we linger on beginner charms for too long."
            c worry "Ohh... you're right. I shouldn't do easy ones forever...."
            s sigh "Do them on your own time, if you want. There are plenty of charm books here that you could borrow."
            c happy "Ehehe, okay~! I'll think about it."
        "10 x 10?":
            pause .1
            c smile "Umm, next was... they got twice as big, right? I mean, it's 10 instead of 5!"
            s raised "That would be 4 times as big."
            c oh "Huh? But 5 plus 5..."
            c oops "Ohhh, because it's 4 squares! Ehehe, sorry for being silly."
            s hmm "(Doesn't surprise me that she can't do math either...)"
        "Do I need to count them?":
            pause .1
            c whine "Senna... Do I need to count them?"
            s sigh "Charms grids are drawn at specific sizes. They'll be ineffective if you don't follow the instructions properly..."
            s hmm "So, yes. You need to count them."
            c oops "Aww, okay... I'll do my best~!"

    s frown "We'll be moving up to 10 x 10 grids tomorrow, so come prepared."
    c smile "Yes, ma'am!"
    c oh "Wait, should I call you ma'am...? You're an underclassman...."
    s sigh "Call me whatever you like. I don't particularly care."
    s frown "Question 3: What is your goal? What do you want from me, as your tutor?"

    menu:
        q "What is your goal?"
        "To graduate!":
            pause .1
            c happy "I want to graduate with everyone! Please teach me more about charms, so I can pass my class!"
        "To learn charms!":
            pause .1
            c happy "I want to learn to draw charms, so I can pass my class! Please teach me!"
        "I'm supposed to have a goal...?":
            pause .1
            c worry "I have to think of a goal now...? Your quizzes are tough..."
            s raised "...You intend to graduate, yes?"
            c whine "I'd like to! I really hope I can..."
            s sigh "Then that's your goal, isn't it? If you want my assistance, you need to follow my instruction."
            c oh "You'll really help me graduate...?"

    s hmm "I intend to. As long as you take these lessons seriously. (I have a lot on my plate right now...)"
    c smile "Yeah~! I'm as serious as can be!"
    s sigh "(Doubtful, but...) I'll take your word for it."
    hide screen chapter_name
    $ save_name = _("Lesson's Over!")
    show screen chapter_name()

    s oh "One last thing... my payment for the day?"
    c happy "Oh, yeah! Where's my bag...?"
    hide cassia
    hide senna

    nvl clear
    n2 "With the day's tutoring session coming to close, the girls gathered their things."
    n2 "Senna tapped her foot as Cassia dug through her messy, overstuffed bag, until..."
    nvl clear

    show cassia happy at appearleft
    show senna at appearright
    c happy "Yay, I found it! Here's your money~! (So glad I didn't forget it at home!)"
    s smile "Thanks. Same time tomorrow, then."
    c smile "Uh-huh~ Bye bye~!"
    hide senna

    c "...."
    c oh "(Huh... that was the first time she smiled~!)"
    hide cassia
    hide cg

    "Was Senna's tutoring really going to help Cassia pass Charms class?"
    "Or was her naivety being exploited to make a quick buck?"
    "None of these things crossed Cassia's mind. Her only thoughts at the time were..."
    nvl clear

    show cassia waaa at appearleft
    c waaa "(Gosh... Senna sure is strict! I better study extra hard tonight to be ready for her next quiz!)"
    c oh "(I wonder if I should practice a little more while I'm here...?)"

    menu:
        q "Would you like to draw a bonus charm?"
        "Yes!":
            pause .1
            $ puzzle = puzzle_easy_candy
            $ extracredit = True
            hide screen chapter_name
            $ save_name = _("Extra Credit!")
            show screen chapter_name()
            return

        "My brain's too tired...":
            pause .1
            c aww "(Naww, I did enough studying for one day~ Time to go home!)"
            hide cassia
            pass

label part2:
    hide screen chapter_name
    nvl clear
    "Cassia left the library with her head in the clouds, as always."
    "She was going to do her best tomorrow, too!"
    nvl clear
    play music title fadeout 2.0

    scene bg study with fade
    hide screen chapter_name
    $ save_name = _("The Next Day")
    show screen chapter_name()
    show cg school at cg
    show cassia happy at appearleft
    c "It's almost time for the next lesson~! I hope it's not too hard!"
    c worry "Senna said we would do 10 x 10 grids today... ohhh, I always messed up on those ones...."
    hide cassia

    nvl clear
    "The young witch hurried along to the library, greeting her friends as she passed by them in the halls."
    "Despite their upcoming finals, the after school atmosphere felt so relaxed..."
    nvl clear
    "\"Hey, Cassia! We're getting crepes after this, wanna join?\""
    "\"Cassia~! We're watching a movie for anime club today--you should come!\""
    nvl clear
    "As much as she would've loved to hang out with everyone... there was no way she could skip her study sessions!"
    nvl clear

    hide cg
    show cg library at cg
    show cassia at appearleft

    hide screen chapter_name
    $ save_name = _("Lesson 4")
    show screen chapter_name()

    c "Hi, Senna~! I'm ready for those 10 x 10 charms you promised!"
    show senna at appearright
    s bored "You're right on time today. Congratulations."
    c happy "Ehehe, I practiced the Temporal charm a lot last night! I'll never be late again~!"
    s sigh "Glad to hear it... so have you memorized the pillars?"
    c oh "Pillows...?"
    s grr "PILLARS. (Ugh...)"
    c smile "Ohh, the magic ones! Yes, I know them!"
    s frown "Recite them for me, please."

    menu:
        q "What are the pillars of the magic circle?"
        "Temporal, Spatial, and Astral Magic!":
            pause .1
            c happy "It's Temporal, Spatial, and Astral Magic! The puzzles from yesterday~!"
            s sigh "Correct. Thank you for paying attention."
        "Star, hourglass, and bubbles!":
            pause .1
            c oh "I remember what they all looked like! It was a star, and an hourglass, and bubbles!"
            s hmm "You mean Temporal Magic, Spatial Magic, and Astral Magic. Please memorize the correct terminology."
            c happy "Oh yeah! Temporal, like the one I practiced!!"
        "Hey, why isn't it a triangle?":
            pause .1
            c oh "Umm, I just realized... If there's 3 pillars, doesn't it make more sense as a triangle?"
            s raised "...What?"
            c whine "The magic circle! It should be a triangle, right? Triangles have 3 points!"
            s mad "It's ALWAYS been represented as a circle. The paths flow into eachother--they aren't as distinct as points!"
            c oh "They flow...?"
            s grr "You're getting us sidetracked already! The pillars are Astral, Temporal, and Spatial magic."
            c smile "Got it! I'll remember the terms for the test~!"
            s sigh "Continuing on, then..."

    s frown "With 10 x 10 grids, we can combine the pillars to achieve more complicated, nuanced effects."
    c oh "Nuanced..."
    s smile "This is where charms start to become interesting. Higher level grids contain more magic, meaning more power."
    s bored "Consequentially, this also makes them more dangerous."
    s sigh "There's a higher potential for mistakes... the effects of which can be multiplicative, as well."
    s frown "Sloppily-drawn charms have even been known to cause explosions and the like."
    c "...."
    s oh "...Cassia? You're following all this, yes?"
    c oops "Ehehe, sorry. I was surprised you smiled again~! So, what were you saying?"
    s shock "I smi...?! Could you please not monitor my facial expressions?!"
    c oh "Huh? Okay~..."
    s mad "If you need something to fixate on, draw this charm instead!"
    hide senna
    #narration?
    c waaa "(Eek! I made her mad....)"
    c worry "(I wonder why...? Maybe cuz I'm s'posed to pay attention to what she's saying, so I can learn...)"
    c happy "(Oh~! That means... she's angry because she thinks I wasn't learning good!)"
    c smile "(Don't worry, Senna~ I'll prove I can do this charm, too!)"
    return

label lesson4:
    $ save_name = _("Lesson 4")
    show cg library at cg
    show cassia at left

    c "Look, Senna! I did it~!"
    show senna grr at appearright
    s "...Well done."
    c happy "It wasn't even as hard as I thought! It must be because of all your help~!"
    c aww "So please don't be mad... I really AM listening!"
    s sigh "...I'm not mad. I was... irate."
    c oh "(Huh? What's the difference...?)"
    s frown "I'm not good with non sequiturs. I reacted too strongly, and I apologize for that."
    c worry "(I think I need a dictionary...)"
    c happy "(Ohh, good thing I'm in the library~!)"
    s hmm "Shall we continue the lesson?"
    c oh "Oh! Yes, please!"

    hide screen chapter_name
    $ save_name = _("Pop Quiz! 2")
    show screen chapter_name()

    s frown "Then, please identify the charm you've just drawn."
    menu:
        q "Which charm did you draw?"
        "Correction Magic!":
            pause .1
            c aww "Oh, I remember! It was Correction Magic! ...Right?"
            s bored "INcorrect. \"Connection\" is the term you're looking for. (Although I'd love to use a correction spell on you...)"
        "Collection Magic!":
            pause .1
            c aww "Oh, I remember! It was Collection Magic! ...Right?"
            s bored "Close, but no. \"Connection\" is the term you're looking for."
            c whine "Aww, I wanted to use this one to help me collect things..."
            s hmm "(The charm for that is completely beyond her.)"
        "Connection Magic!":
            pause .1
            c smile "Oh, I remember! It was Connection Magic!"
            s sigh "Correct."

    s frown "Connection charms are the union between Temporal and Spatial magic."
    c happy "Union...? Ohh, it's like they're married~! <3"
    s hmm "...Please don't humanize the pillars. (Unless it helps you memorize them, I suppose...)"
    s sigh "Now, what practical purpose does this charm serve?"
    menu:
        q "What are connection charms used for?"
        "Portals?":
            pause .1
            c oh "If it's time and space... you mean, umm..."
            c smile "Is it like warping somewhere? Like on the InsteRail!"
            s frown "Yes, the InsteRail is an advanced system of portals, accessible by all. It's a marvel of the magical world."
        "Calling friends!":
            pause .1
            c smile "Oh, I know! It's like with mirror calls, how you can see the other person on the other side~!"
            s frown "Yes, this type of charm is indeed drawn into the frames of mirrors."
            c oh "Then how come I've never seen them there? I always thought you just had to cast a spell like normal..."
            s bored "Do you want the entire frame of your mirror to be covered in carvings? They're drawn small and inconspicuous on purpose."
            c happy "So they're drawn as teeny-tiny secret charms... how cute~!"
        "It must be... love~!":
            pause .1
            c smile "Connection... oh, like a romantic connection!"
            s hmm "Not in the slightest."
            c whine "Aww, it's not love...?"
            s grr "No. It is the physical proximity between spaces in time. Surely you understand how portal magic works."
            c happy "Say... speaking of love, is there anybody you have a crush on?"
            s mad "Cassia, we are in the middle of a lesson. How many times have I asked you to take this seriously?!"
            c whine "But I just worked so hard on this one~! I wanna get some girl talk in! <3"
            s grr "I will end this session RIGHT NOW if you insist on discussing such frivolous things."
            c oops "Ehehe... sorry... I'll stay focused."

    # s "Connection magic, as the name implies, connects two or more places."
    hide screen chapter_name
    $ save_name = _("Lesson 5")
    show screen chapter_name()

    s sigh "Here. It's time to move on to the next charm."
    s frown "I picked up an extra shift tonight, so I'll be finishing some of my homework while you solve these."
    c oh "Got it! I won't bother you, then...!"

    return

label lesson5:
    $ save_name = _("Lesson 5")
    show cg library at cg
    show cassia at left

    c "...."
    c waaa "(Senna's focused on her homework... I don't want to interrupt her!)"
    c oh "(She said she has an extra shift... I wonder what kind of job she has...?)"
    c smile "(I've never had one... what's it like...?)"
    c happy "(Maybe if I had a job, people would think that I'm hardworking and reliable, too~! That'd be nice...)"
    show senna hmm at appearright
    s "What are you smiling about. Have you finished yet?"
    c smile "Oh, yes! Hehe, I didn't wanna interrupt you..."
    s sigh "The sooner our session ends, the sooner I can return to my other responsibilities. Tell me right away next time."
    c happy "Okay~!"

    s frown "Counting this one, how many charms have you drawn so far?"
    menu:
        q "How many charms have you drawn?"
        "5!":
            pause .1
            c oh "Let's see... This is the second one today... and then there was Astral, and Temporal, and Spatial..."
            c happy "So that's 5! 5 whole charms~!"
            s hmm "(She had to count them on her fingers...)"
        "6~!":
            pause .1
            c oh "Let's see... This is the second one today... and then there was Astral, and Temporal, and Spatial..."
            if extracredit:
                c smile "Oh, and the extra one I did yesterday~! I checked out a charm book, like you said!"
                s oh "...You practiced after I left? Good effort, Cassia."
                c happy "Yay~ I was praised! <3"
            else:
                c whine "Or... wait, did I do 3 today? Now I can't remember!"
                s hmm "You've done 2. So it's 5 total."
                c smile "Oh, right! I remember now."
        "I wasn't keeping track...":
            pause .1
            c waaa "I didn't know I was s'posed to count them...! I don't know the answer..."
            s bored "This was the 5th. I'd like to train you to pay attention to smaller details."
            c happy "Being trained sounds fun... hehe, dogs always look so happy~!"
            s sigh "(Is she aiming to become a familiar...?)"

    s frown "Moving right along... Illusion magic is born from the spatial and astral pillars."
    s sigh "It's a projection over reality. The soul, manifested in physical space."
    c oh "Soul...?"
    s bored "Yes, Astral magic relates to the soul."
    c whine "I thought you said it was stars..."
    s grr "The pillars are fluid. They're referred to by different names in various cultures."
    c worry "They're water now, too?!"
    s mad "FLUID, as in flexible! (Is she just messing with me?!)"
    c oh "Ohhh... so they can mean anything?"
    s hmm "The pillars of the magic circle bleed into one another. It's a spectrum... like colors in a rainbow."
    c happy "I love rainbows~!"
    s sigh "Yes... what I'm saying is, the categories were prescribed after the fact, to make magic easier to research and study."
    c whine "Whaaat? But... it's not easier at all!"
    c worry "These charms take so much time to draw... I liked learning magic better when it was more about feelings!"
    s grr "Operating on feelings alone means you'll never reach your full potential. (Magic has so much more to offer...!)"
    c smile "Say, which one are you? Like, in the magic rainbow."
    s mad "Spectrum!"
    c aww "Yeah, that! What's your specialty, Senna~?"
    s raised "I presume you're only asking because you want to tell me yours..."

    menu:
        q "What kind of magic are you good with?"
        "Slowing down~":
            pause .1
            c happy "Everyone tells me that time seems to slow down whenever I'm around... so maybe I'm a Temporal Witch!"
            s hmm "(These sessions certainly feel agonizingly long...)"
        "Drawing Charms!":
            pause .1
            c happy "I'm good with charms! ...Or at least, I wanna be~!"
            s hmm "Well... you've made SOME progress, at the very least."
        "Illusions, maybe?":
            pause .1
            c oh "I never thought about it... I like doing all kinds of spells!"
            c happy "I think illusions are my favorite, though... I didn't know the charm looks like a cute flower~!"
            s bored "Yes, I suppose it does."

    c smile "So, what about you? I barely know anything about you, Senna~!"
    s sigh "...I'm aiming to become a Logician. My specialties lie in Truth magic."
    c oh "Truth magic...! Is that the next charm?"
    s bored "No. Truth is the inverse of Illusion--a concept that isn't taught until Charms II."
    c worry "Inverse...? There's even MORE categories?!"
    s frown "Yes, but you don't have to worry about them for the time being. For now, just complete this next charm."
    hide screen chapter_name
    $ save_name = _("Lesson 6")
    show screen chapter_name()
    c oh "Oh, sure..."
    hide senna
    c waaa "(There's so much stuff I still have no clue about... am I really gonna be able to pass...?)"
    return

label lesson6:
    $ save_name = _("Lesson 6")
    show cg library at cg
    show cassia worry at left
    show senna at appearright
    c worry "Senna... I did it, but... I'm starting to get worried!"
    s bored "About?"
    c waaa "What if I forget everything you taught me? What if I can't pass the final...?"
    s sigh "It's a possibility. That's why you have to keep working hard."
    c worry "Okay... I'll do my best!"
    s frown "Our time is nearly up, so let's make that the last charm for the day."
    s sigh "The Growth charm consists of which two pillars?"
    menu:
        q "Which pillars combine to create Growth magic?"
        "Astral and Temporal!":
            pause .1
            c smile "The only ones we haven't matched yet are Astral and Temporal magic... so it's those two, right~?"
            s bored "Correct."
        "Soul and... time?":
            pause .1
            c oh "Umm... the other one was... soul and space, so... is it soul and time?"
            s hmm "Astral and Temporal. Is it that hard to remember their proper names?"
            c whine "C'mon, if you know what I mean, why does it matter~?"
            s mad "Because \"soul and time\" won't be written on the test! "
            c worry "Okay... I'll remember, it's Astral and Temporal."
        "This one is plants!!!":
            pause .1
            c smile "There's leaves on this one! So it's like plant magic!"
            c happy "That means... you should combine sunlight and water to make it grow!"
            s raised "That's... not at all the answer I was looking for."
            c oh "It's the star one for sunshine! And... I guess there's no water charm...."
            c smile "Then, time! Because it takes a long time for plants to grow!!"
            s sigh "Well... you've managed to arrive at the correct answer. Albeit by fluke."

    s frown "The Growth charm affects progress. Its regenerative properties make it very useful to healers."
    c happy "Ohh~ like the little leaves they draw on healing patches! So that's why they're like that~!"
    s hmm "Yes... it's mainly represented as plants, but \"Growth\" means soul over time."
    c smile "I get it~! Because plants grow~! <3"
    c oh "So, does other stuff that grows fit in that category, too...? What about hair?"
    s raised "Well, there IS the popular myth that a witch's magical power can be judged by the length of their hair..."
    c waaa "That's a myth?!"
    s bored "Ah... Did you grow your hair out thinking it'd increase your proficiency with magic?"
    c worry "I dunno...! Lots of really cool witches have long hair...."
    s sigh "(This girl is hopeless...)"
    c whine "Do you think I'd pass the final if I cut my hair...? What if it's weighing me down...?!"
    s grr "Cassia. You are a third-year student failing a mid-level course at an expensive private academy for witches."
    s "You've been relying on a first-year to explain basic concepts to you; concepts that were taught as early as middle school."
    c worry "I-I... um..."
    s mad "AND, on top of this, your answers are often childish and immature. You have zero regard for the gravity of your situation."
    s "It is infuriating for me to see a witch in your position waste every opportunity she's been given. WHAT are you thinking?"
    c waaa "Um... so, a-a haircut won't help?"
    s shock "No! Why would it?!"
    c worry "I'm sorry... please don't be mad at me...."
    s sigh "...."
    s grr "You're right. Lecturing you won't make any difference. (Even though everything I said was true...)"
    s frown "Know that I have nothing against you, personally, Cassia. It's the principle of the matter."
    c waaa "(It sure FEELS personal...!)"
    s bored "I had merely hoped that laying out the facts would inspire some sort of change in you. Some Growth, perhaps."
    c oops "Y...yeah...! I want to get better~..."
    s sigh "With all that aside, I must ask..."
    s hmm "What do you plan to do after graduation?"
    menu:
        q "What will you do after graduating?"
        "I should go to college, right?":
            pause .1
            c worry "Um... I gotta apply for college, right? Like everybody else is...?"
            s mad "Don't decide such things so half-heartedly!"
            s grr "In fact, don't pursue higher education at all if you're only going to waste more of your parents' money."
            c smile "(So I don't have to go...? That's good, I think!)"
            s bored "Whether or not you had plans to pursue a degree wasn't in question for me..."
        "Take a big nap":
            pause .1
            c happy "I think I'll be so worn out, I'll just take a big nap~ ...Ahh, I'm getting sleepy...."
        "All kinds of fun stuff!":
            pause .1
            c happy "That's easy! I wanna drink tea, and eat marshmallows, and be around everyone I love~!"

    s raised "What I meant was in terms of a career."
    c oh "Ohhh. A career..."
    c oops "Ehe, I dunno~ How's anyone s'posed to know what they wanna do at 17?"
    s hmm "I know what I want to do."
    c oh "You do?"
    s frown "I'm going to apply for every scholarship I can, and scrape together all the funding I need to get accepted into the top school for witches."
    s mad "After that, I'll obtain my degree, and become the most powerful, well-respected Logician in the world. No, in history!"
    c smile "Wow... you already know what you'll be doing for the whole rest of your life...!"
    c happy "That's amazing, Senna~! You're so smart, I know you can do it!"
    s raised "I can, and I will. Do you know what that starts with?"
    c smile "...?"
    s bored "My payment. For the tutoring session."
    c oh "Oh, right!"
    hide cassia
    hide senna
    hide cg

    hide screen chapter_name
    $ save_name = _("Lesson's Over...?")
    show screen chapter_name()

    nvl clear
    "Cassia handed over another small pouch full of coins, and Senna left the library in a confident stride."
    "As she watched her go, Cassia couldn't help but think..."
    nvl clear

    show cassia worry at appearleft
    c worry "(Having your whole life planned out... isn't that kinda, y'know...)"
    c "(Stifling...?)"
    c aww "(Aww, but she's really serious about her goals... that's like, totally admirable!)"
    c smile "(I need to get serious, too... Gotta study lots and lots!)"

    menu:
        q "Would you like to draw a bonus charm?"
        "Yeah~!":
            pause .1
            $ puzzle = puzzle_mid_cat
            $ extracredit = True
            hide screen chapter_name
            $ save_name = _("Extra Credit!")
            show screen chapter_name()
            return

        "No thanks...":
            pause .1
            c happy "(I'll have lots of time tomorrow! Time to go home~!)"
            hide cassia

label part3:
    hide screen chapter_name
    play music title fadeout 2.0

    scene bg study with fade
    hide screen chapter_name
    $ save_name = _("The Last Day")
    show screen chapter_name()
    show cg school at cg
    show cassia at appearleft

    c "Today's the last tutoring session... will the charms be even bigger this time, I wonder?"
    c oh "Gosh, I hope I can do them! I don't wanna disappoint Senna!"

    hide cassia

    nvl clear
    "Cassia hurried once again to the library."
    "But when she got there..."
    "Senna was nowhere to be found."
    nvl clear
    hide cg
    show cg library at cg
    show cassia oh at appearleft

    c "Huh...? (I'm not late, right...?)"
    c waaa "(Or, am I too early? Did I draw my Temporal charms wrong...?!)"
    hide cassia

    n2 "Cassia waited at her usual seat, looking around at the other students who studied in silence."
    n2 "More and more time passed... but Senna still hadn't appeared."
    nvl clear
    show cassia worry at appearleft
    c worry "(Gosh, I hope nothing bad happened... Should I go out and look for her...?)"
    c oh "(No... if she comes and I'm not here, she'll think I was late!)"
    c smile "(It's best just to wait. I think I'll find a charm to do on my own~!)"

    hide cg
    $ save_name = _("Lesson 7")
    return

label lesson7:

    show cg library at cg
    show cassia happy at left
    c happy "Yay~ I did it!"
    c "...."
    c worry "(It's lonely without Senna here... even if she can be a little harsh sometimes....)"
    c oh "(Oh...! Maybe she's mad at me after all...?)"
    c waaa "(Maybe she doesn't wanna tutor me anymore, because she thinks I'm a dummy... and that I'm wasting her time...)"
    show senna gloom at appearright
    s gloom "Cassia! Please excuse my tardiness..."
    c happy "Oh, Senna! You're here~!"
    s "Yes, I..."
    s oh "Hm? You were doing charms on your own?"
    c smile "Uh-huh! I even finished one while I was waiting for you~!"
    s smile "You... you've done well. Great work."
    c happy "Ehehe, I got worried that you didn't wanna tutor me anymore... I'm glad you came after all~!"
    s sigh "No, I... I had extenuating circumstances."
    c aww "It's good that you don't hate me... hehe, I don't know what I would do~!"
    s oh "Hate you...?"
    s grr "Of course not. I told you before that I have nothing against you, personally."
    c whine "But... you're always getting mad at me for being childish!"
    c waaa "And you think that I'm wasting opportunities... and you think that I don't listen...."
    c "But I don't know any other way to be! A-all I can do is try my best...!"
    s sad "...."
    s gloom "Cassia... you're right. All I've done is look down on you."
    c oh "(Huh...? She's admitting it?)"
    s sad "The truth is, I..."
    s gloom "I was dismissed from a separate tutoring job today. The client cited \"poor attitude\" as a contributing factor..."
    c "Oh... was that your extra shift from yesterday?"
    s oh "Hm? No, no... I also work as a cashier in the student store."
    c oops "You have too many jobs, Senna... it's no wonder you're so cranky!"
    s sigh "I'm doing what I must."
    s sad "But, still... it's no excuse. A teacher shouldn't look down on her student. It's inconducive to learning."
    c worry "...."
    s gloom "I've done wrong by you, Cassia. Can you ever forgive me?"
    menu:
        q "Forgive Senna?"
        "Okay~":
            pause .1
            c smile "Okay <3 I forgive you."
        "Hmm........":
            pause .1
            c oh "Hmmmm~ What should I do...."
            s gloom "If you'd rather dismiss me as well, I... I probably deserve it."
            c smile "No... I still need a tutor. So I won't dismiss you!"
        "No!":
            pause .1
            c no "No, I won't forgive you!"
            c smile "At least... not until you teach me how to do more charms!"

    s oh "Really? After how I've treated you all this time...?"
    c happy "As long as you'll be nice to me from now on, I think it's fine~! We can be friends!"
    s aww "It'd be a short-lived friendship, considering you're about to graduate..."
    c oh "Oh, yeah..."
    c happy "Ohhhh, that means you believe in me~! Aww, thanks, Senna~! <3"
    s smile "You seem to have gotten the basics down quite well by now... I think you're ready for a 15 x 15 grid."
    c oh "15...? That's so big!"
    hide screen chapter_name
    $ save_name = _("Final Lesson")
    show screen chapter_name()
    s mad "This will be your final lesson, Cassia. If you can complete this charm, you'll have no trouble passing the class!"
    c no "O-okay! Got it!"
    s sad "Start with the edges... A-and remember, you can add up the numbers and subtract from 15 to find the amount of spaces required!"
    c happy "Don't worry, I'll figure it out~!"
    c oops "(But I don't want to do math... I mean, it's faster to just guess!)"
    s oh "I-I'll leave you to it, then... Good luck!"
    hide senna
    hide cg
    return

label lesson8:
    $ theend = True
    play music puzzle1 fadeout 2.0
    show cg library at cg
    show cassia oh at appearleft
    show senna oh at appearright
    c "I think... that's all the squares!"
    s "Which means... you've done it!"
    c happy "I did a 15 x 15 charm... all by myself!"
    s raised "Well, this one wasn't so difficult."
    s gloom "Er... my apologies. That was rude, wasn't it?"
    c "Ehehe, I'm so happy, I don't care~! I did it!!!"
    hide cg
    # hide senna
    # hide cassia
    show cg hug at cg
    show senna blush
    c happy "Thanks soooo much, Senna!!! <3"
    s "--!!!"
    s flustered "P-p-p-please refrain from such overt displays of affection!"
    c smile "Huh, why? You don't like hugs~?"
    s mad "Y-you shouldn't throw yourself onto others without their explicit consent! NOW who's being rude?!"
    hide cg
    hide senna
    hide cassia

    nvl clear
    "Cassia released Senna from her embrace, and the younger witch straightened her mantle in a huff..."
    "...But it was clear that she was at least a little happy about Cassia's great achievement."
    nvl clear
    show cg library at cg
    show cassia at appearleft
    show senna hmm at appearright
    c "Are you sure I don't need to practice more big charms like this one? You don't wanna tutor me over the weekend?"
    s sigh "No... I agreed to 3 sessions knowing I could teach you everything you needed to know in that time."
    s frown "You have all the tools to study on your own from here. All that remains is to explain the meaning of the Magic Circle charm."
    c oh "Oh, right! Gotta learn the meaning, too..."
    s sigh "This charm is..."
    s smile "Well, why don't you tell me what you think it means first?"
    menu:
        q "What does the Magic Circle charm mean?"
        "Love!":
            pause .1
            c happy "It must be LOVE!"
        "Harmony~!":
            pause .1
            c happy "Oh, it's gotta mean harmony~!"
        "World Peace! <3":
            pause .1
            c happy "I think it means world peace!"

    s raised "And why is that?"
    c smile "Because... the whole circle is getting along!"
    s bored "That's... close enough, I suppose."
    s smile "This charm offers stability in time, space, and the soul... in other words, it helps to prevent negative outcomes."
    c happy "Really~? That's so strong!"
    s frown "Charms aren't infallible. They can be broken, just like any other spell..."
    s smile "But if you practice drawing this, you'll surely be able to graduate. You're on a fixed path, after all."
    c oh "A fixed path...?"
    s bored "You seem to be quite a lucky individual. You live a charmed life, Cassia."
    c smile "But I didn't know how to draw charms until now! So that means..."
    c happy "My life can only be charmed from now on~!"
    hide cassia
    hide senna

    hide screen chapter_name
    $ save_name = _("Ending")
    show screen chapter_name()

    nvl clear
    n2 "Senna stifled her laughter."
    n2 "It seems even SHE isn't immune to Cassia's charm..."
    n2 "Somehow, they had truly become friends."
    nvl clear
    hide cg

    "As for the rest..."
    "Thanks to Senna's help, Cassia was able to pass Charms class."
    nvl clear

    show cg school at cg
    show cassia happy at appearleft
    c "I got a C~! C for \"Cassia\"~!"
    show senna raised at appearright
    s "Not a C for \"Charm\"?"
    c oh "Oh, that's good, too..."
    c smile "You're so smart, Senna."
    s smile "Naturally. I'm aiming to become a renowned Logician, after all."
    hide senna
    hide cassia

    "And she would, one day."
    "...but that's a story for another time."
    "First, she would need to attend Cassia's graduation."
    nvl clear

label ending:
    hide screen chapter_name
    $ quick_menu = False
    $ _game_menu_screen = None
    stop music fadeout 3.0
    $ block()
    scene cg end with Fade(1,0,2)
    play music title
    pause

    scene bg pink with Dissolve(1)

    show credit game
    if preferences.language is not None:
        show tlcredit
    with dissolve

    pause

    hide credit
    hide tlcredit
    with dissolve

    show patroncredit
    show credit names
    with dissolve

    pause

    hide credit
    hide patroncredit
    with dissolve

    show credit thanks
    with dissolve

    pause

    hide credit with dissolve
    pause 1

    $ persistent.clear = True
    python:
        if renpy.variant("pc"):
            mp.charmstudies = True
            mp.save()
label to_title:
    show titlelogo:
        align (.5,.25)
    with dissolve
    $ renpy.full_restart()
